Attribute VB_Name = "PrtDraw"
Option Explicit
'**********************************************************************
'* Module: prtdraw.bas
'* Aufruf der Funktionen aus der .\utils\prtdraw.dll
'* MEGATECH Software GmbH, MegaCAD_3D_2004
'* AURICH Innenprojekt GmbH, K.Hiller, 06.07.2004
'**********************************************************************
Public Type tRECT
  lLeft    As Long
  lTop     As Long
  lRight   As Long
  lBottom  As Long
End Type

Public Type tMACRO
  lX  As Long
  lY  As Long
  psName As Long
  psInfo As Long
  lInfoSize As Long
  lContinue As Long
End Type

Private PrtDrawMacro As tMACRO


'**********************************************************************/
'typedef int (_stdcall *tfpDrawPrt)(
'        char *fname,           // .PRT - file
'        HDC  hDC,              // device context
'        RECT *rDisp,           // display rectangle
'        RECT *rVirt,           // virtual rectangle (zooming)
'        RECT *rClip,           // clipping rectangle
'        uint flags );          // bits 0-3 background colour (VGA)
'                               // bit 4 => F_STOREMAK

'prtdraw.dll-Funktionsaufruf - DrawPrtFile - Funktionsnummer 1
'Achtung String mit Lnge und Abschlu NULL wird als ByVal deklariert,
'aber durch VB intern als C-String ByRef an die DLL bergeben
Declare Function DrawPrt Lib "C:\Programme\MegaCAD_3D_2004\Utils\prtdraw.dll" Alias "#1" ( _
        ByVal sFName As String, _
        ByVal hDC As Long, _
        ByRef tRectDisp As Any, _
        ByRef tRectVirt As Any, _
        ByRef tRectClip As Any, _
        ByVal lFlags As Long) As Long
'return value :
'    >0  => version number of MegaCAD - file (ok)
'    =0  => no valid MegaCAD - file
'    -1  => could not open file 'fname'
'    -2  => everything clipped, nothing drawn
'    -3  => out of memory

'flag F_STOREMAK prepares for macro loop (see below)
Public Const F_STOREMAK As Byte = 2 ^ 5 ' (1<<4)
Public Const F_MONO     As Byte = 2 ^ 6 ' (1<<5)

'**********************************************************************/
'typedef void (_stdcall *tfpSetIni)(
'        char *szIni );     // name of a 'megacad.ini' filePublic Type t_fpSetIni

'prtdraw.dll-Funktionsaufruf - SetMegaIni - Funktionsnummer 2
'Achtung String mit Lnge und Abschlu NULL wird als ByVal deklariert,
'aber durch VB intern als C-String ByRef an die DLL bergeben
Declare Sub SetIni Lib "C:\Programme\MegaCAD_3D_2004\Utils\prtdraw.dll" Alias "#2" ( _
        ByVal sIni As String)

'**********************************************************************/
'
'Die folgenden Funktionen sind nicht getestet!!!
'
'**********************************************************************/

'**********************************************************************/
'typedef long (_stdcall *tfpMakLoop)(
'        tfpMakCB func,          // Callback function
'        void     *cbPtr );      // pointer to user defined data

'prtdraw.dll-Funktionsaufruf - MakroLoop - Funktionsnummer 3
Private Declare Function MakLoop Lib "C:\Programme\MegaCAD_3D_2004\Utils\prtdraw.dll" Alias "#3" ( _
                ByVal pfMacCB As Long, _
                ByRef pbData As Any) As Long
'return value :
'   number of Macros

'**********************************************************************/
'typedef int (_cdecl *tfpMakCB)(
'        int   px,               // point of reference: x
'        int   py,               // point of reference: y
'        uchar *fname,           // filename of macro file
'        uchar *info,            // macro info (each line '\0'-terminated)
'        uint  isize,            // size (in bytes) of macro info
'        void  *cbPtr );         // pointer to user defined data

'Callback Funktion fr MakroLoop (separates Modul *.bas erforderlich)
Private Function MakCB( _
        ByVal lX As Long, _
        ByVal lY As Long, _
        ByVal sFName As String, _
        ByRef sInfo As String, _
        ByVal lInfoSize As Long, _
        ByRef pbData As Long) As Long
  
  
  PrtDrawMacro.lX = lX
  PrtDrawMacro.lY = lY
  PrtDrawMacro.psName = sFName
  PrtDrawMacro.psInfo = sInfo
  PrtDrawMacro.lInfoSize = lInfoSize
  PrtDrawMacro.lContinue = 2 ^ 0 + 2 ^ 1 + 2 ^ 2 + 2 ^ 3    '+ 2 ^ 4
  
  'Warten bis Marcowerte abgefragt wurden oder maximal 5 sec. pro Makro
  Dim Pausenlnge As Single
  Pausenlnge = 5         ' Dauer festlegen
  Dim EndTime As Single
  EndTime = Pausenlnge + Timer      ' Endzeit setzen
  Do
    DoEvents   ' Steuerung an andere Prozesse abgeben.
  Loop While (Timer < EndTime) Or (PrtDrawMacro.lContinue > 0)
  
  'wenn nicht Continue gesetzt wurde, dann MakLoop abbrechen
  If PrtDrawMacro.lContinue > 0 Then PrtDrawMacro.lContinue = 0
  
  'Rckgabewert mit Hilfe der Benuzterdefiniertendaten zuweisen
  '   ==0  => break loop
  '   !=0  => continue loop
  MakCB = PrtDrawMacro.lContinue
End Function

'Setzt den Wert fr die Fortsetzung der MacLoop
Public Sub SetMacContinue(blWeiter As Boolean)
  If blWeiter Then
    PrtDrawMacro.lContinue = -1
  Else
    PrtDrawMacro.lContinue = 0
  End If
End Sub

'bergibt die X-Koordinaten des Bezugspunktes auf dem DC
Public Function GetMacX() As Long
  GetMacX = PrtDrawMacro.lX
  PrtDrawMacro.lContinue = PrtDrawMacro.lContinue And (Not CLng(2 ^ 0))
End Function

'bergibt die Y-Koordinaten des Bezugspunktes auf dem DC
Public Function GetMacY() As Long
  GetMacY = PrtDrawMacro.lY
  PrtDrawMacro.lContinue = PrtDrawMacro.lContinue And (Not CLng(2 ^ 1))
End Function

'bergibt den Name des Makros (FileName)
Public Function GetMacName() As String
  GetMacName = PrtDrawMacro.psName
  PrtDrawMacro.lContinue = PrtDrawMacro.lContinue And (Not CLng(2 ^ 2))
End Function

'bergibt das Makro Info als Sting mit Zeilenumbruch
Public Function GetMacInfo() As String
  Dim i As Long
  Dim s As String
  s = ""
  For i = 0 To PrtDrawMacro.lInfoSize
    s = s & PrtDrawMacro.psInfo & vbCrLf
  Next
  PrtDrawMacro.lContinue = PrtDrawMacro.lContinue And (Not CLng(2 ^ 3))
End Function

'bergibt einen Zeiger auf die Internen Makro-Daten
'Public Function GetMacData() As Long
'  GetMacData = PrtDrawMacro.pbData
'  PrtDrawMacro.lContinue = PrtDrawMacro.lContinue And (Not CLng(2 ^ 4))
'End Function

'Sucht nach enthaltenen Makros in der geffneten Datei und stellt die Daten
'in den GetMac-Funktionen zur Verfgung
'Der Rckgabewert ist die Anzahl der vorhandenen Makros
Public Function MacLoop() As Long
  Dim pbData As Long
  MacLoop = MakLoop(AddressOf MakCB, pbData)
End Function
'**********************************************************************/
'if 0      // documentation
'**********************************************************************/

'simple example using complete DC, no zooming

'void DrawPrt(
'        HWND hwnd,
'        HDC  hdc,
'        char *fname,
'        char *szIni )
'{
'    static HMODULE mhPrtDraw = NULL;
'
'    tfpDrawPrt fpDrawPrt = NULL;
'    tfpSetIni  fpSetIni  = NULL;
'
'    if ( !hwnd ) // at program exit
'    {
'        if ( mhPrtDraw )
'        {
'            FreeLibrary(mhPrtDraw);
'            mhPrtDraw = NULL;
'        }
'        return;
'    }
'    if ( !mhPrtDraw )
'        mhPrtDraw = LoadLibrary("prtdraw.dll"); // path ??
'    Else
'        szIni = NULL; // only first time
'    if ( mhPrtDraw )
'    {
'        fpDrawPrt = (tfpDrawPrt)GetProcAddress(mhPrtDraw,FN_DRAWPRT);
'        fpSetIni  = (tfpSetIni) GetProcAddress(mhPrtDraw,FN_SETINI );
'    }
'    if ( szIni && fpSetIni )
'        fpSetIni(szIni);
'    if ( fpDrawPrt )
'    {
'        RECT rect;
'        GetWindowRect(hwnd,&rect);
'        GetClientRect(hwnd,&rect);
'        DPtoLP(hdc,(LPPOINT)&rect,2);
'        fpDrawPrt(fname,hdc,&rect,NULL,NULL,15);
'    }
'}
'
'**********************************************************************/
'endif  // 0 (documentation)
'**********************************************************************/
